import processing.serial.*;
Serial myPort;

int button_color=250;
int button_fire=220;
boolean button1_over=false;
boolean button2_over=false;
boolean button3_over=false;
boolean button4_over=false;
boolean button5_over=false;
boolean button6_over=false;
char letter;
int speed=150;
int speed_min=0;
int speed_max=250;
int step=10;


void setup ()
{
  size (500, 400);
  String portName=Serial.list()[0];
  myPort=new Serial(this, portName, 9600);
  println(Serial.list());
}



void draw() {
  update(mouseX, mouseY);
  background(180);
  fill(0);
  text("скорость =", 100, 50);
  text(speed, 165, 50);
  text("направление -", 250, 50);
  switch (letter) {
    case 'w': text("вперед", 340, 50); break;
    case 's': text("назад", 340, 50); break;
    case 'a': text("влево", 340, 50); break;
    case 'd': text("вправо", 340, 50); break;
  }
  
  
  if(button1_over) {fill(button_fire);}
  else {fill(button_color);}
  rect(50,100,100,100);
  
  if(button2_over) {fill(button_fire);}
  else {fill(button_color);}
  rect(200,100,100,100);
  
  if(button3_over) {fill(button_fire);}
  else {fill(button_color);}
  rect(350,100,100,100);
  
  if(button4_over) {fill(button_fire);}
  else {fill(button_color);}
  rect(50,250,100,100);
  
  if(button5_over) {fill(button_fire);}
  else {fill(button_color);}
  rect(200,250,100,100);
  
  if(button6_over) {fill(button_fire);}
  else {fill(button_color);}
  rect(350,250,100,100);
  
  fill(0);
  text("скорость-", 75, 150);
  text("вперед", 225, 150);
  text("скорость+", 370, 150);
  text("влево", 80, 300);
  text("назад", 227, 300);
  text("вправо", 380, 300);
  
  
  myPort.write(letter);
  myPort.write(speed);
  myPort.write(" ");
  delay(30);
}


void update(int x, int y)
{
  if(proverka_button1() ){
    button1_over=true;
    button2_over=false;
    button3_over=false;
    button4_over=false;
    button5_over=false;
    button6_over=false;}
    else if(proverka_button2() ){
    button1_over=false;
    button2_over=true;
    button3_over=false;
    button4_over=false;
    button5_over=false;
    button6_over=false;}
    else if(proverka_button3() ){
    button1_over=false;
    button2_over=false;
    button3_over=true;
    button4_over=false;
    button5_over=false;
    button6_over=false;}
    else if(proverka_button4() ){
    button1_over=false;
    button2_over=false;
    button3_over=false;
    button4_over=true;
    button5_over=false;
    button6_over=false;}
    else if(proverka_button5() ){
    button1_over=false;
    button2_over=false;
    button3_over=false;
    button4_over=false;
    button5_over=true;
    button6_over=false;}
    else if(proverka_button6() ){
    button1_over=false;
    button2_over=false;
    button3_over=false;
    button4_over=false;
    button5_over=false;
    button6_over=true;}
        
    else {button1_over = button2_over = button3_over = button4_over = button5_over = button6_over = false;}
}


void mouseClicked(){
  if(button1_over){speed=speed-step;}
  if(button3_over){speed=speed+step;}
  if(speed<speed_min){speed=speed_min;}
  if(speed>speed_max){speed=speed_max;}
  
  if(button2_over){letter='w';}
  if(button4_over){letter='a';}
  if(button5_over){letter='s';}
  if(button6_over){letter='d';}
}
  
  
boolean proverka_button1(){
  if(mouseX>50&&mouseX<150&&mouseY>100&&mouseY<200) {return true;}
  else {return false;}
}  

boolean proverka_button2(){
  if(mouseX>200&&mouseX<300&&mouseY>100&&mouseY<200) {return true;}
  else {return false;}
}

boolean proverka_button3(){
  if(mouseX>350&&mouseX<450&&mouseY>100&&mouseY<200) {return true;}
  else {return false;}
}

boolean proverka_button4(){
  if(mouseX>50&&mouseX<150&&mouseY>250&&mouseY<350) {return true;}
  else {return false;}
}

boolean proverka_button5(){
  if(mouseX>200&&mouseX<300&&mouseY>250&&mouseY<350) {return true;}
  else {return false;}
}

boolean proverka_button6(){
  if(mouseX>350&&mouseX<450&&mouseY>250&&mouseY<350) {return true;}
  else {return false;}
}
